%include rice wavelet toolbox (for comparison purposes)
path(path,'rwt');

%compile code
mex densityLevelSet2DTI.c

% read image
% f = ones(512)*128;
% f(6:508,6:508) = double(imread('StLouis.gif'));
load StLouisTrue;
n = size(f,1);
gamma = 110/sum(f(:))*n*n;
f = f/sum(f(:))*n*n;
I = f;
y = poissrnd(I);
N = sum(y(:));
	
A = max(f(:));

S = (f >= gamma);
R_S = sum((gamma-f(:)).*(2*S(:)-1)/2/A);

Sy = (y/sum(y(:))*n*n >= gamma);
R_Sy = sum((gamma-f(:)).*(2*Sy(:)-1)/2/A);


% TI Version
if 0 % find ideal penalty weight
  penWeightVec = linspace(0,1,100);
  RVec = zeros(100,1);
  for k = 1:length(penWeightVec)
    S_hat = densityLevelSet2DTI(y,gamma,1/n/n,penWeightVec(k)*sqrt(A));
    RVec(k) = sum((gamma-f(:)).*(2*S_hat(:)-1)/2/A);
    fprintf('k = %d, R = %f\n',k,RVec(k));
  end
  [junk,mink] = min(RVec);
  penWeight = penWeightVec(mink)
else
  penWeight = 0.15;
end

S_hat = densityLevelSet2DTI(y,gamma,1/n/n,penWeight*sqrt(A));
R_Shat = sum((gamma-f(:)).*(2*S_hat(:)-1)/2/A);
% R_Shat-R_S
% figure(5);imagesc(S_hat(6:508,6:508));axis image; colormap gray; axis off; title('S-est = proposed estimate');colorbar


h = daubcqf(2);
[wL,wH] = mrdwt(y,h);

if 0 % find ideal wavelet threshold
  threshVec = linspace(0,10,100);
  RVec = zeros(100,1);
  for k = 1:length(threshVec)
    f_denoise = mirdwt(wL,HardTh(wH,threshVec(k)),h);
    S_denoise = (f_denoise/sum(f_denoise(:))*n*n >= gamma);
    RVec(k) = sum((gamma-f(:)).*(2*S_denoise(:)-1)/2/A);
    fprintf('k = %d, R = %f\n',kaiser,RVec(k));
  end
  [junk,mink] = min(RVec);
  thresh = threshVec(mink)
else
  thresh = 3.53;
end
f_denoise = mirdwt(wL,HardTh(wH,thresh),h);
S_denoise = (f_denoise/sum(f_denoise(:))*n*n >= gamma);
R_Sdenoise = sum((gamma-f(:)).*(2*S_denoise(:)-1)/2/A);

C_l = 0;
C_u = max(I(:));

figure(1);imagesc(I(6:508,6:508),[C_l,C_u]); axis image;colormap gray; axis off;title('True f');colorbar
figure(2);imagesc(S(6:508,6:508));axis image; colormap gray; axis off; title('True S');colorbar
figure(3);imagesc(y(6:508,6:508),[0,ceil(C_u)]); axis image;colormap gray; axis off; title('y = Noisy f');;colorbar
figure(4);imagesc(Sy(6:508,6:508));axis image; colormap gray; axis off;title('S_y = thresholded y');;colorbar
figure(5);imagesc(S_hat(6:508,6:508));axis image; colormap gray; axis off; title('S-est = proposed estimate');colorbar
figure(6);imagesc(S_denoise(6:508,6:508));axis image; colormap gray; axis off; title('S-est_p = plug-in estimate');colorbar

fprintf('R(S_y)-R(S) = %f\n',R_Sy-R_S);
fprintf('R(S_hat)-R(S) = %f\n',R_Shat-R_S);
fprintf('R(S_denoise)-R(S) = %f\n',R_Sdenoise-R_S);


